;#########################################################################################

; WinTreeSnap, v.2015-02-06
; (Windows 95/98/Me/NT4/2000/XP/Vista/7/8/...)

;#########################################################################################

; COMMAND LINE PARAMETER (ways of ordering the window hierarchy):
;
;  _e    :  Enum-order via EnumChildWindows                    ; (01h) 
;  _el                                                         ; (02h) 
;  _g    :  Z-order via 'GetWindowTree'                        ; (03h) 
;  _gl                                                         ; (04h) 
;  _f    :  Z-order via 'FindWindowTree'                       ; (05h) 
;  _fl                                                         ; (06h) 
;  _gm   :  Z-order via 'GetWindowTreeMem'                     ; (07h) 
;  _gml                                                        ; (08h) 
;  _zd   :  true Z-down-order via 'GetWindowTreeZD'            ; (09h) 
;  _zdl                                                        ; (0Ah) 
;  _zu   :  true Z-up-order via 'GetWindowTreeZU'              ; (0Bh) 
;  _zul                                                        ; (0Ch) 
;
;    *l  :  * with loop  (Run;   Shift => snap,  Esc => exit)

;#########################################################################################

; GetOSver
; CreateToolhelp32Snapshot_
; Process32First_
; Process32Next_
; PidToName
; GetMessageWindow
; GetAncestorParent
; Winfo0
; Winfo
; FindWindowTree
; GetWindowTree
; GetWindowTreeMem
; GetWindowTreeZD
; GetWindowTreeZU

;#########################################################################################

; %MASM%\ml /Cp /Gz /c /coff /I\masm32\include %NAME%.asm

.386
.model flat,stdcall
option casemap:none

inclib macro x
 include x.inc
 includelib x.lib
endm

include windows.inc
inclib user32
inclib kernel32
inclib gdi32
inclib shlwapi
inclib comctl32

.const

.data

  var        dd              01h ; (default variant)

  _e         db "_e",0    ;  01h
  _el        db "_el",0   ;  02h
  _g         db "_g",0    ;  03h
  _gl        db "_gl",0   ;  04h
  _f         db "_f",0    ;  05h
  _fl        db "_fl",0   ;  06h
  _gm        db "_gm",0   ;  07h
  _gml       db "_gml",0  ;  08h
  _zd        db "_zd",0   ;  09h
  _zdl       db "_zdl",0  ;  0Ah
  _zu        db "_zu",0   ;  0Bh
  _zul       db "_zul",0  ;  0Ch

 _format1    db " !! THIS IS A TABLE !!",13,10
             db " !! Set your text editor to WORD-UNWRAP & MONOSPACED FONT (Courier, FixedSys,...) !!",13,10,13,10
             db "                     |---------------siblings---------------|",13,10
             db "  Owner     Parent    First     Last      Prev      Next      Child     HWND      %s    Tree                 Status      Width  Height       "
             db "X       Y    Id/hMenu  DlgCtrlID       TID       PID      pPID    "
             db "Exec.file%18shInstance  hModule  C.WndProc  WndProc   UserData  ExStyles  Styles    "
             db "C.Styles  ClsExt  WndExt   Atom    Class%34s""Send WM_GETTEXT"" /GetWindowText (if unequal)",13,10,13,10,0

 _format2    db "%10.8lx%10.8lx%10.8lx%10.8lx%10.8lx%10.8lx%10.8lx%10.8lx%7d%6d"
             db " %-16s  %s"
             db "%9d%8d%8d%8d%12.x%10.x%11.lx%10.lx%10.lx"
             db "    %-26s"
             db "%10.8lx%10.8lx%10.8lx%10.8lx%10.8lx%10.8lx%10.8lx%10.8lx%8d%8d%7.4x"
             db "    %-38s ""%s"" %s",13,10,0

 _format3    db 13,10," Windows %s  %lu.%lu.%lu  %s  %s",0
 
 _format4    db "%s",13,10,13,10
             db " DoubleByteCharacterSet: %s",13,10
             db " InputMethodManager:     %s",13,10,13,10
             db " Foreground:%21.8lx",13,10
             db " Focus:%26.8lx",13,10
             db " Cursor over window:   > (%d,%d)",13,10,13,10
             db " Status: uNICODE/aNSI, Topmost/, Layered/,  Visible/Hidden,  Enabled/Disabled,  Maximized/mINIMIZED,  0/1/2/3 (NonRegion/NullRegion/SimpleRegion/ComplexRegion)",13,10,13,10
             db " Output: wts_[number of usual windows]_[number of message-only windows]_[TickCount]_[variant].txt",13,10,13,10
             db "  2004-2015  WinTreeSnap by kero <geocities.com/xmemor>, v.2015-02-06%s",13,10,13,10,0

 _cmndlnprm  db "----------------",13,10
             db "   COMMAND LINE PARAMETERS:",13,10,13,10
             db "    _e     :  Enum-order via EnumChildWindows   // = Z-order, if IMM = ""-""   // default variant",13,10
             db "    _el    :",13,10
             db "    _g     :  Z-order via 'GetWindowTree' (GetWindow/GW_CHILD/GW_HWNDNEXT + GetAncestor/GA_PARENT)",13,10
             db "    _gl    :",13,10
             db "    _f     :  Order via 'FindWindowTree' (FindWindowEx + GetAncestor/GA_PARENT)  // = Z-order  (!)",13,10
             db "    _fl    :",13,10
             db "    _gm    :  Z-order via 'GetWindowTreeMem' (GetWindow/GW_CHILD/GW_HWNDNEXT + memory buffer instead of GetAncestor/GA_PARENT)",13,10
             db "    _gml   :",13,10
             db "    _zd    :  Z-down-order via 'GetWindowTreeDown' (GetWindow/GW_CHILD/GW_HWNDLAST/GW_HWNDPREV + GetAncestor/GA_PARENT)",13,10
             db "    _zdl   :",13,10
             db "    _zu    :  Z-up-order via 'GetWindowTreeUp' (GetWindow/GW_CHILD/GW_HWNDNEXT + GetAncestor/GA_PARENT)",13,10
             db "    _zul   :",13,10,13,10
             db "        *l :  variants with Sleep-loop:  Shift => get snap & wait again,  Esc => exit.",13,10
             db "----------------",13,10,0
 _format5    db "wts_%.4lu_o%.3lu_%.10lu%s.txt",0
 
 _status     db "        ",0
 _zord       db "Z-ord",0
 _enum       db " Enum",0
 _plus       db "+",0
 _minus      db "-",0
 _mesowin    db 13,10," Message-only (Windows 98/Me/NT>=2k):",13,10,13,10,0
 _tout       db "<<WTS_timeout_error>>",0
 _hw_desk    db "HWND_DESKTOP",0
 _hw_mess    db "HWND_MESSAGE",0
 _user32     db "user32",0
 _kernel32   db "kernel32",0
 _z          db  0

.data?

 hdesk       dd ?
 hmess       dd ?
 count       dd ?  ; all windows
 count0      dd ?  ; 0-level usual windows
 count0o     dd ?  ; 0-level message-only windows
 lp_bigbuf   dd ?
 lp_wtbuf    dd ?
 hrgn        dd ?
 hwfirst     dd ?
 hwlast      dd ? 
 hwprev      dd ?
 hwnext      dd ?
 hwchild1    dd ?
 hwparent    dd ?
 hwowner     dd ?
 hinst       dd ?
 hmodule     dd ?
 wp1         dd ?  ; wndproc1
 wp2         dd ?  ; wndproc2
 id          dd ?  ; id_hmenu
 cid         dd ?  ; dlgctrlid
 tid         dd ?  ; threadid
 pid         dd ?  ; processid
 ppid        dd ?  ; parentprocessid
 wndx        dd ?  ; wndextra
 clsx        dd ?  ; clsextra
 usrd        dd ?  ; userdata
 wsx_        dd ?  ; exstyle
 ws_         dd ?  ; style
 cs_         dd ?  ; class_style
 atom        dd ?
 hSnapshot   dd ?
 winlevel    dd ?
 hwfr        dd ?  ; hwforegrnd
 hwfc        dd ?  ; hwfocus
 pt          POINT <>
 rt          RECT <>  
; pe32        PROCESSENTRY32 <>
 shiftbuf    db 128 dup(?)
 wintext1    db 128 dup(?)
 wintext2    db 128 dup(?)
 windowfile  db MAX_PATH dup(?)
 winclass    db MAX_PATH dup(?)
 buffer      db 1024 dup(?)

.code

;####################################################################################

GetOSver proc uses ebx edi esi lpbuf:DWORD
  
SYSTEM_INFO_ struct
  wProcessorArchitecture       dw ?
  wReserved                    dw ?
  dwPageSize                   dd ?
  lpMinimumApplicationAddress  dd ?
  lpMaximumApplicationAddress  dd ?
  dwActiveProcessorMask        dd ?
  dwNumberOfProcessors         dd ?
  dwProcessorType              dd ?
  dwAllocationGranularity      dd ?
  wProcessorLevel              dw ?
  wProcessorRevision           dw ?
SYSTEM_INFO_ ends

OSVERSIONINFO_ struct
  dwOSVersionInfoSize          dd ?
  dwMajorVersion               dd ?
  dwMinorVersion               dd ?
  dwBuildNumber                dd ?
  dwPlatformId                 dd ?
  szCSDVersion                 db 128 dup (?)
OSVERSIONINFO_ ends

OSVERSIONINFOEX_ struct
  dwOSVersionInfoSize          dd ?
  dwMajorVersion               dd ?
  dwMinorVersion               dd ?
  dwBuildNumber                dd ?
  dwPlatformId                 dd ?
  szCSDVersion                 db 128 dup (?)
  wServicePackMajor            dw ?
  wServicePackMinor            dw ?
  wSuiteMask                   dw ?
  wProductType                 db ?
  wReserved                    db ?
OSVERSIONINFOEX_ ends

  local vi:OSVERSIONINFO_
  local vix:OSVERSIONINFOEX_
  local s_i:SYSTEM_INFO_

.data
 _os                           db 13,10," Windows %s  %d.%d  %d  %s  %s",0
 _w95                          db "95",0
 _w98                          db "98",0
 _Me                           db "Me",0
 _nt                           db "NT",0
 _w2000                        db "2000",0
 _XP                           db "XP",0
 _s2003                        db "Server 2003",0
 _s2003R                       db "Server 2003 R2",0
 _XP64                         db "XP Pro x64",0
 _sHome                        db "Home Server",0
 _Vista                        db "Vista",0
 _s2008                        db "Server 2008",0
 _s2008R                       db "Server 2008 R2",0
 _w7                           db "7",0
 _s2012                        db "Server 2012",0
 _w8                           db "8",0
 _s2012R                       db "Server 2012 R2",0
 _w81                          db "8.1",0
 _x86                          db "x86",0
 _x64                          db "x64",0
 _IA64                         db "IA64",0
 _unknown                      db "processor_architecture_unknown",0
;_kernel32                     db "kernel32",0
 _GetNativeSystemInfo          db "GetNativeSystemInfo",0
;_z                            db 0
.code  

  invoke RtlZeroMemory,addr s_i,sizeof s_i
  invoke GetModuleHandleA,offset _kernel32
  invoke GetProcAddress,eax,offset _GetNativeSystemInfo
  .if eax==0  ; for Win2000 ?
    invoke GetSystemInfo,addr s_i
  .else
    lea edx,s_i
    push edx
    call eax
  .endif

  mov ax,s_i.wProcessorArchitecture
  .if ax==PROCESSOR_ARCHITECTURE_AMD64
    mov edi,offset _x64
  .elseif ax==PROCESSOR_ARCHITECTURE_IA64
    mov edi,offset _IA64
  .elseif ax==PROCESSOR_ARCHITECTURE_INTEL
    mov edi,offset _x86
  .elseif ax==PROCESSOR_ARCHITECTURE_UNKNOWN
    mov edi,offset _unknown
  .else
    mov edi,offset _z
  .endif

  invoke GetSystemMetrics,SM_SERVERR2
  mov esi,eax

  invoke RtlZeroMemory,addr vi,sizeof vi
  mov vi.dwOSVersionInfoSize, sizeof vi
  invoke GetVersionEx,addr vi

  invoke RtlZeroMemory,addr vix,sizeof vix
  mov vix.dwOSVersionInfoSize,sizeof vix
  invoke GetVersionExA,addr vix

  xor ecx,ecx
  mov cx,vix.wSuiteMask      ; Ex
  and cx,8000h               ; VER_SUITE_WH_SERVER

  xor edx,edx
  mov dh,vix.wProductType    ; Ex

  .if vi.dwPlatformId==VER_PLATFORM_WIN32s ; =0
    mov ebx,offset _z
  .elseif vi.dwPlatformId==VER_PLATFORM_WIN32_WINDOWS ; =1
    .if vi.dwMinorVersion==0
      mov ebx,offset _w95
    .elseif vi.dwMinorVersion==10
      mov ebx,offset _w98
    .elseif vi.dwMinorVersion==90
      mov ebx,offset _Me
    .else
      mov ebx,offset _z
    .endif
  .elseif vi.dwPlatformId==VER_PLATFORM_WIN32_NT ; =2
    .if vi.dwMajorVersion==3 && vi.dwMinorVersion==51
      mov ebx,offset _nt    
    .elseif vi.dwMajorVersion==4 && vi.dwMinorVersion==0
      mov ebx,offset _nt
    .elseif vi.dwMajorVersion==5 && vi.dwMinorVersion==0
      mov ebx,offset _w2000
    .elseif vi.dwMajorVersion==5 && vi.dwMinorVersion==1
      mov ebx,offset _XP
    .elseif vi.dwMajorVersion==5 && vi.dwMinorVersion==2 && dh==VER_NT_WORKSTATION && s_i.wProcessorArchitecture==PROCESSOR_ARCHITECTURE_AMD64
      mov ebx,offset _XP64
    .elseif vi.dwMajorVersion==5 && vi.dwMinorVersion==2 && ecx!=0
      mov ebx,offset _sHome
    .elseif vi.dwMajorVersion==5 && vi.dwMinorVersion==2 && esi==0
      mov ebx,offset _s2003
    .elseif vi.dwMajorVersion==5 && vi.dwMinorVersion==2 && esi!=0
      mov ebx,offset _s2003R
    .elseif vi.dwMajorVersion==6 && vi.dwMinorVersion==0 && dh==VER_NT_WORKSTATION
      mov ebx,offset _Vista
    .elseif vi.dwMajorVersion==6 && vi.dwMinorVersion==0 && dh!=VER_NT_WORKSTATION
      mov ebx,offset _s2008      
    .elseif vi.dwMajorVersion==6 && vi.dwMinorVersion==1 && dh==VER_NT_WORKSTATION
      mov ebx,offset _w7
    .elseif vi.dwMajorVersion==6 && vi.dwMinorVersion==1 && dh!=VER_NT_WORKSTATION
      mov ebx,offset _s2008R
    .elseif vi.dwMajorVersion==6 && vi.dwMinorVersion==2 && dh==VER_NT_WORKSTATION
      mov ebx,offset _w8
    .elseif vi.dwMajorVersion==6 && vi.dwMinorVersion==2 && dh!=VER_NT_WORKSTATION
      mov ebx,offset _s2012
    .elseif vi.dwMajorVersion==6 && vi.dwMinorVersion==3 && dh==VER_NT_WORKSTATION
      mov ebx,offset _w81
    .elseif vi.dwMajorVersion==6 && vi.dwMinorVersion==3 && dh!=VER_NT_WORKSTATION
      mov ebx,offset _s2012R
    .else
      mov ebx,offset _z
    .endif
  .else
    mov ebx,offset _z
  .endif
@@:
  .if vi.dwPlatformId==VER_PLATFORM_WIN32_WINDOWS
    and vi.dwBuildNumber,0FFFFh
  .endif
  invoke wsprintfA,lpbuf,offset _os,ebx,vi.dwMajorVersion,vi.dwMinorVersion,vi.dwBuildNumber,addr vi.szCSDVersion,edi
  ret
GetOSver endp

; OS                           dwMajorVersion   dwMinorVersion   dwPlatformId                       wProductType               GetSystemMetrics(SM_SERVERR2)
; Windows 8.1	            6.3*        6              3	         VER_PLATFORM_WIN32_NT              == VER_NT_WORKSTATION
; Windows Server 2012 R2	6.3*	      6	             3	         VER_PLATFORM_WIN32_NT              != VER_NT_WORKSTATION
; MSDN: " * For applications that have been manifested for Windows 8.1. Applications not manifested for 8.1 will return the Windows 8 OS version value (6.2)."

;#########################################################################################

CreateToolhelp32Snapshot_ proc arg1:DWORD,arg2:DWORD   ; for WinNT4
.data
 _CreateToolhelp32Snapshot db "CreateToolhelp32Snapshot",0
.code
  invoke GetModuleHandle,offset _kernel32
  invoke GetProcAddress,eax,offset _CreateToolhelp32Snapshot
  test eax,eax
  jz @f
  push arg2
  push arg1
  call eax
@@:
  ret
CreateToolhelp32Snapshot_ endp

;#########################################################################################

Process32First_ proc arg1:DWORD,arg2:DWORD
.data
 _Process32First db "Process32First",0
.code
  invoke GetModuleHandle,offset _kernel32
  invoke GetProcAddress,eax,offset _Process32First
  test eax,eax
  jz @f
  push arg2
  push arg1
  call eax
@@:
  ret
Process32First_ endp

;#########################################################################################

Process32Next_ proc arg1:DWORD,arg2:DWORD
.data
 _Process32Next db "Process32Next",0
.code
  invoke GetModuleHandle,offset _kernel32
  invoke GetProcAddress,eax,offset _Process32Next
  test eax,eax
  jz @f
  push arg2
  push arg1
  call eax
@@:
  ret
Process32Next_ endp

;#########################################################################################

PidToName proc uses ebx edi esi pId:DWORD
;
PROCESSENTRY32_ struct
  dwSize                dd ?    
  cntUsage              dd ?    
  th32ProcessID         dd ?    
  th32DefaultHeapID     dd ? ; ULONG_PTR 
  th32ModuleID          dd ?    
  cntThreads            dd ?    
  th32ParentProcessID   dd ?    
  pcPriClassBase        dd ? ; LONG      
  dwFlags               dd ?    
  szExeFile             db MAX_PATH dup(?)
PROCESSENTRY32_ ends
;
local pe32:PROCESSENTRY32_
;
  invoke RtlZeroMemory,addr pe32,sizeof pe32
  mov pe32.dwSize,sizeof pe32
  invoke Process32First_,esi,addr pe32

  invoke CreateToolhelp32Snapshot_,TH32CS_SNAPPROCESS,pid
;  mov hSnapshot,eax
  mov esi,eax
  mov pe32.dwSize,sizeof pe32
  invoke Process32First_,esi,addr pe32
@@:
  test eax,eax
  jz @false
  mov eax,pid
  cmp pe32.th32ProcessID,eax
  jz @f
  invoke Process32Next_,esi,addr pe32
  jmp	@b
@@:
  invoke lstrcpy,addr windowfile,addr pe32.szExeFile
  mov edx,pe32.th32ParentProcessID
  mov ppid,edx
  invoke PathStripPath,eax  ; (for Win98)
  jmp	@f

@false:
;  mov pe32_.th32ParentProcessID,eax
  mov ppid,eax
  mov	eax,offset windowfile
  mov	word ptr [eax],[0]['?']
@@:
  push eax
  invoke CloseHandle,esi
  pop eax
  ret
PidToName endp

;#########################################################################################
; root message-only window (Win98, WinMe, Win2000, WinXP, WinVista, Win7, Win8,...)

GetMessageWindow proc uses ebx edi
  xor edi,edi
  invoke FindWindowEx,HWND_MESSAGE,0,0,0   ; for NT>=2k
  test eax,eax
  jz @f
  invoke GetWindowLong,eax,GWL_HWNDPARENT
  mov edi,eax
  jmp @ret
@@:
  invoke GetModuleHandle,0                 ; for Win98, WinMe, NT>=2k
  invoke CreateWindowEx,WS_EX_TOOLWINDOW,32770,0,WS_POPUP,0,0,0,0,HWND_MESSAGE,0,eax,0
  test eax,eax
  jz @f
  push eax
  invoke GetWindowLong,eax,GWL_HWNDPARENT
  mov edi,eax
  call DestroyWindow
  jmp @ret
@@:
  invoke GetModuleHandle,0                ; for Win98, WinMe, NT>=2k
  invoke CreateWindowEx,WS_EX_TOOLWINDOW,32770,0,WS_POPUP,0,0,0,0,0,0,eax,0
  mov ebx,eax
  invoke SetParent,ebx,HWND_MESSAGE
  test eax,eax
  jz @f
  invoke GetWindowLong,ebx,GWL_HWNDPARENT
  mov edi,eax
@@:
  invoke DestroyWindow,ebx
@ret:
  mov eax,edi
  ret
GetMessageWindow endp

;#########################################################################################

GetAncestorParent proc uses ebx hWnd:HWND  ; for Win95: instead of "GetAncestor(hWnd,GA_PARENT)"

.data
; _user32      db "user32",0
 _GetAncestor db "GetAncestor",0
.code
  invoke GetModuleHandle,offset _user32
  invoke GetProcAddress,eax,offset _GetAncestor
  test eax,eax
  jz @f
  push GA_PARENT
  push hWnd
  call eax
  jmp @ret
@@:
  invoke GetWindowLong,hWnd,GWL_HWNDPARENT
  mov ebx,eax
  invoke GetWindow,hWnd,GW_OWNER
  .if eax==0 && ebx!=0
    mov eax,ebx
  .else
    invoke GetDesktopWindow
  .endif
@ret:
  ret
GetAncestorParent endp

;#########################################################################################

Winfo0 proc hWnd:HWND,param:DWORD
  inc count
  xor eax,eax
  inc eax
  ret
Winfo0 endp

;#########################################################################################

Winfo proc uses ebx edi esi hWnd:HWND,lParam:DWORD
  local bu[9]:BYTE
  
  xor eax,eax
  mov byte ptr wintext2,al
  lea edi,bu
  invoke lstrcpy,edi,offset _status
  mov ebx,offset shiftbuf
  mov dword ptr [ebx],'    '
  add ebx,3

  mov eax,hWnd
  mov edx,var
  .if eax==hdesk
    mov eax,offset _hw_desk
    jmp @f
  .elseif eax==hmess
    mov eax,offset _hw_mess
@@:
    xor ecx,ecx
    dec ecx
    mov winlevel,ecx
    invoke lstrcpy,ebx,eax
  .else
    .if edx==1 || edx==2                  ; Enum-ord
      xor esi,esi
      .while (eax!=hdesk && eax!=hmess)
        mov byte ptr [ebx],'.'						; show w-tree
        inc ebx
        inc esi
;       invoke GetAncestor,eax,GA_PARENT
        invoke GetAncestorParent,eax
      .endw
      mov word ptr [ebx-1],[0]['w']
      dec esi
      mov winlevel,esi
    .else                                 ; Z-ord
      mov edx,winlevel
      .while edx>0
        mov byte ptr [ebx],'.'				    ; show w-tree
        inc ebx
        dec edx
      .endw
      mov word ptr [ebx],[0]['w']
    .endif
  .endif

  mov ebx,hWnd
  invoke GetWindowRect,ebx,addr rt
  mov eax,rt.left
  mov ecx,rt.top
  cmp pt.x,eax
  jl @f
  mov edx,rt.right
  cmp pt.x,edx
  jg @f
  cmp pt.y,ecx
  jl @f
  mov edx,rt.bottom
  cmp pt.y,edx
  jg @f
  mov byte ptr shiftbuf+1,'>'			        ; cursor - over window
@@:
  sub rt.right,eax                        ; width
  sub rt.bottom,ecx                       ; height

  cmp winlevel,0
  jnz @f
  inc count0
@@:
  invoke IsWindowUnicode,ebx
  .if eax==0
    mov al,'a'                           ; a(nsi)
  .else
    mov al,'u'                           ; u(nicode)
  .endif
  mov byte ptr [edi],al

  mov dword ptr [edi+3],'mDH '				    ; H(idden)D(isable)m(inimized)
  invoke IsWindowVisible,ebx
  test eax,eax
  jz @f
  mov byte ptr [edi+4],'V'						    ; V(isible)
@@:
  invoke IsWindowEnabled,ebx
  test eax,eax
  jz @f
  mov byte ptr [edi+5],'E'						    ; E(nable)
@@:
  invoke IsIconic,ebx
  test eax,eax
  jnz	@f
  mov	byte ptr [edi+6],'M'						    ; M(aximized)
  invoke IsZoomed,ebx
  test	eax,eax
  jnz	@f
  mov	byte ptr [edi+6],' '						    ; (normal)
@@:
  invoke GetClassName,ebx,addr winclass,MAX_PATH-1
  
  invoke SendMessageTimeout,ebx,WM_GETTEXT,127,addr wintext1,SMTO_ABORTIFHUNG,100,0			; timeout: 100 ms
  test eax,eax
  jnz @f
  invoke lstrcpy,addr wintext1,offset _tout
@@:
  invoke lstrlen,offset wintext1
  mov esi,offset wintext1
  xor ecx,ecx
  .while ecx!=eax
    mov dl,byte ptr [esi+ecx]
    .if dl>=0 && dl<20h
      mov byte ptr [esi+ecx],''
    .endif
    inc ecx
  .endw

  invoke GetWindowText,ebx,addr wintext2+1,127
  invoke lstrlen,offset wintext2+1
  mov esi,offset wintext2+1
  xor ecx,ecx
  .while ecx!=eax
    mov dl,byte ptr [esi+ecx]
    .if dl>=0 && dl<20h
      mov byte ptr [esi+ecx],''
    .endif
    inc ecx
  .endw

  invoke lstrcmp,addr wintext1,addr wintext2+1
  test eax,eax
  jz @f
  mov	byte ptr wintext2,'/'
@@:
  invoke GetWindowLong,ebx,GWL_STYLE
  mov ws_,eax
  invoke GetWindowLong,ebx,GWL_EXSTYLE
  mov	wsx_,eax
  
  test eax,WS_EX_LAYERED
  jz	@f
  mov	byte ptr [edi+3],'L'						    ; Layered
@@:
  test eax,WS_EX_TOPMOST
  jz @f
  mov	byte ptr [edi+2],'T'						    ; Topmost
@@:
  invoke GetWindowRgn,ebx,hrgn
  add	al,48
  mov	byte ptr [edi+7],al							    ; region type: 0 ("window hasn't region" or ERROR), 1 (NULLREGION), 2 (SIMPLEREGION), 3 (COMPLEXREGION)

  invoke GetWindow,ebx,GW_OWNER
  mov hwowner,eax
  
;  invoke GetAncestor,ebx,GA_PARENT
  invoke GetAncestorParent,ebx
  mov	hwparent,eax

  .if ebx==hmess                          ; XP-pro-sp2:  GetWindow(hmess,GW_HWNDPREV) => app's crash ! 
    xor eax,eax
    xor ecx,ecx
  .else
    invoke GetWindow,ebx,GW_HWNDPREV
    push eax
    invoke GetWindow,ebx,GW_HWNDLAST
    push eax
    invoke GetWindow,ebx,GW_HWNDFIRST
    pop edx
    pop ecx    
  .endif
  mov hwprev,ecx
  mov hwlast,edx
  mov hwfirst,eax

  invoke GetWindow,ebx,GW_HWNDNEXT
  mov hwnext,eax                        ; XP-pro-sp2 / Win7:  GetWindow(hmess,GW_HWNDNEXT) => strange value, but without app's crash.

  invoke GetWindow,ebx,GW_CHILD
  mov hwchild1,eax
  invoke GetWindowLong,ebx,GWL_ID
  mov	id,eax
  invoke GetDlgCtrlID,ebx
  mov	cid,eax
  invoke GetWindowLong,ebx,GWL_HINSTANCE 
  mov	hinst,eax
  invoke GetWindowLong,ebx,GWL_USERDATA
  mov	usrd,eax
  invoke GetWindowLong,ebx,GWL_WNDPROC
  mov	wp1,eax
  invoke GetClassLong,ebx,GCL_WNDPROC
  mov	wp2,eax
  invoke GetClassLong,ebx,GCL_HMODULE
  mov	hmodule,eax
  invoke GetClassLong,ebx,GCL_STYLE
  mov	cs_,eax
  invoke GetClassLong,ebx,GCL_CBCLSEXTRA
  mov clsx,eax
  invoke GetClassLong,ebx,GCL_CBWNDEXTRA
  mov wndx,eax
  invoke GetClassLong,ebx,GCW_ATOM
  mov	atom,eax

  invoke GetWindowThreadProcessId,ebx,addr pid
  mov	tid,eax

  invoke PidToName,pid

  invoke wsprintf,\
    offset buffer,offset _format2,\
    hwowner,hwparent,hwfirst,hwlast,hwprev,hwnext,hwchild1,ebx,count,winlevel,\
    offset shiftbuf,edi,\
    rt.right,rt.bottom,rt.left,rt.top,id,cid,tid,pid,ppid,\
    eax,\
    hinst,hmodule,wp2,wp1,usrd,wsx_,ws_,cs_,clsx,wndx,atom,\
    offset winclass,offset wintext1,offset wintext2

  invoke lstrcat,lp_bigbuf,offset buffer
  inc count
  xor eax,eax
  inc eax
  ret
Winfo endp

;###########################################################################################

FindWindowTree proc uses ebx edi hWnd:HWND
  mov eax,hWnd
@inc:
  inc winlevel
@0:
  mov ebx,eax
  invoke Winfo,ebx,0
  invoke FindWindowEx,ebx,0,0,0  ; (child-1)
  test eax,eax
  jnz @inc
@dec:
;  invoke GetAncestor,ebx,GA_PARENT
  invoke GetAncestorParent,ebx
  mov edi,eax
  invoke FindWindowEx,eax,ebx,0,0  ; (next)
  test eax,eax
  jnz @0
  mov ebx,edi
  dec winlevel
  cmp ebx,hWnd
  jnz @dec
  ret
FindWindowTree endp

;###########################################################################################

GetWindowTree proc uses ebx hWnd:HWND
  mov eax,hWnd
@inc:
  inc winlevel
@0:
  mov ebx,eax
  invoke Winfo,ebx,0
  invoke GetWindow,ebx,GW_CHILD  ; (child-1)
  test eax,eax
  jnz @inc
@dec:
  invoke GetWindow,ebx,GW_HWNDNEXT
  test eax,eax
  jnz @0
;  invoke GetAncestor,ebx,GA_PARENT
  invoke GetAncestorParent,ebx
  mov ebx,eax
  dec winlevel
  cmp ebx,hWnd
  jnz @dec
  ret
GetWindowTree endp

;###########################################################################################

GetWindowTreeMem proc uses ebx edi esi hWnd:HWND
  mov eax,hWnd
  mov edi,lp_wtbuf
  xor esi,esi
@inc:
  inc winlevel
@0:
  mov ebx,eax
  invoke Winfo,ebx,0
  invoke GetWindow,ebx,GW_CHILD
  test eax,eax
  jz @dec
  mov dword ptr[edi+4*esi],ebx
  inc esi
  jmp @inc
@dec:
  invoke GetWindow,ebx,GW_HWNDNEXT
  test eax,eax
  jnz @0
  dec esi
  mov ebx,dword ptr[edi+4*esi]
  dec winlevel
  cmp ebx,hWnd
  jnz @dec
  ret
GetWindowTreeMem endp

;###########################################################################################

GetWindowTreeZD proc uses ebx hWnd:HWND
  mov eax,hWnd
@inc:
  inc winlevel
@0:
  mov ebx,eax
  invoke Winfo,ebx,0
  invoke GetWindow,ebx,GW_CHILD
  invoke GetWindow,eax,GW_HWNDLAST
  test eax,eax
  jnz @inc
@dec:
  invoke GetWindow,ebx,GW_HWNDPREV
  test eax,eax
  jnz @0
;  invoke GetAncestor,ebx,GA_PARENT
  invoke GetAncestorParent,ebx
  mov ebx,eax
  dec winlevel
  cmp ebx,hWnd
  jnz @dec
  ret
GetWindowTreeZD endp

;###########################################################################################

GetWindowTreeZU proc uses ebx hWnd:HWND
  mov eax,hWnd
  mov winlevel,-1
@inc:
  inc winlevel
  mov ebx,eax
  invoke GetWindow,ebx,GW_CHILD
  test eax,eax
  jnz @inc
@dec:  
  dec winlevel
  invoke Winfo,ebx,0
  cmp ebx,hWnd
  jz @f
  invoke GetWindow,ebx,GW_HWNDNEXT
  test eax,eax
  jnz @inc
;  invoke GetAncestor,ebx,GA_PARENT
  invoke GetAncestorParent,ebx
  mov ebx,eax
  jmp @dec
@@:
  ret
GetWindowTreeZU endp

;###########################################################################################

start:

  push ebx
  invoke GetCommandLine
  mov ebx,eax
  invoke lstrlen,ebx
  add ebx,eax
  xor ecx,ecx
  .while cl!='"'
    dec ebx
    mov cl,byte ptr[ebx]
  .endw
  add ebx,2
  push edi
  xor edi,edi
  inc edi
  push offset _zul
  push offset _zu  
  push offset _zdl
  push offset _zd
  push offset _gml
  push offset _gm
  push offset _fl
  push offset _f
  push offset _gl
  push offset _g
  push offset _el
  push offset _e
  
  .while edi<0Dh
    pop edx
    invoke lstrcmp,ebx,edx
    .if eax==0
      mov var,edi
    .endif
    inc edi
  .endw

  pop edi
  pop ebx

@start:
  mov edx,var
  .if edx==2 || edx==4 || edx==6 || edx==8 || edx==10 || edx==12  ; (WTS-In-Loop)
    invoke Sleep,40
    invoke GetAsyncKeyState,VK_ESCAPE                                  ; (exit)
    test eax,8000h
    jnz @exit
    invoke GetAsyncKeyState,VK_SHIFT                                   ; (snap)
    test eax,8000h
    jz @start
@@:
    invoke Sleep,40
    invoke GetAsyncKeyState,VK_SHIFT
    test eax,8000h
    jnz @b
  .endif

  xor eax,eax	
  mov count,eax
  
  invoke GetDesktopWindow
  mov hdesk,eax
  invoke EnumChildWindows,eax,offset Winfo0,0

  invoke GetMessageWindow
  mov hmess,eax
  test eax,eax
  jz @f
  invoke EnumChildWindows,hmess,offset Winfo0,0  
@@:
  mov eax,count
  mov ecx,eax
  shl ecx,2                                            ;    4*(number of windows) bytes: own dword for every window
  shl eax,10																           ; 1024*(number of windows) bytes: for summary wintree info
  add eax,ecx
  mov count,ecx
  invoke VirtualAlloc,0,eax,MEM_COMMIT,PAGE_READWRITE
  mov lp_wtbuf,eax
  add eax,count
  mov lp_bigbuf,eax
  
  invoke GetCursorPos,addr pt
  invoke GetCurrentThreadId
  mov tid,eax
  invoke GetForegroundWindow
  mov hwfr,eax
  invoke GetWindowThreadProcessId,eax,0
  mov count0,eax
  invoke AttachThreadInput,eax,tid,TRUE
  invoke GetFocus
  mov hwfc,eax
  mov edx,var
  .if edx==1 || edx==2
    mov edx,offset _enum
  .else
    mov edx,offset _zord
  .endif
  invoke wsprintf,offset buffer,offset _format1,edx,offset _z,offset _z
  invoke lstrcpy,lp_bigbuf,offset buffer

  invoke AttachThreadInput,count0,tid,FALSE
  
  xor	eax,eax
  mov	count,eax
  mov	count0,eax
  mov	count0o,eax
  
  invoke CreateRectRgn,eax,eax,eax,eax
  mov hrgn,eax
  mov edx,var
  .if edx==1 || edx==2
    invoke Winfo,hdesk,0
    invoke EnumChildWindows,hdesk,offset Winfo,0
  .elseif edx==3 || edx==4
    invoke GetWindowTree,hdesk
  .elseif edx==5 || edx==6
    invoke FindWindowTree,hdesk
  .elseif edx==7 || edx==8
    invoke GetWindowTreeMem,hdesk
  .elseif edx==9 || edx==10
    invoke GetWindowTreeZD,hdesk
  .else ; if edx==11 || edx==12
    invoke GetWindowTreeZU,hdesk
  .endif
  
  mov ecx,count                                    ;  count0
  mov count0o,ecx	 ;  number of all usual windows  ;  number of all top-level windows
  xor eax,eax
  mov count0,eax
  mov count,eax  
  
  mov eax,hmess
  test eax,eax
  jz @f
  invoke lstrcat,lp_bigbuf,offset _mesowin
  mov edx,var
  .if edx==1 || edx==2
    invoke Winfo,hmess,0
    invoke EnumChildWindows,hmess,offset Winfo,0       ; (message-only windows CAN BE ENUMERATED, MSDN isn't right :-)
  .elseif edx==3 || edx==4
    invoke GetWindowTree,hmess		                     ; (message-only windows HAS Z-ORDER, MSDN isn't right :-)
  .elseif edx==5 || edx==6
    invoke FindWindowTree,hmess		                     ; (message-only windows HAS Z-ORDER, MSDN isn't right :-)
  .elseif edx==7 || edx==8
    invoke GetWindowTreeMem,hmess
  .elseif edx==9 || edx==10
    invoke GetWindowTreeZD,hmess
  .else ; if edx==11 || edx==12
    invoke GetWindowTreeZU,hmess
  .endif
@@:
  invoke GetOSver,offset wintext1

  invoke GetSystemMetrics,SM_DBCSENABLED
  push eax
  invoke GetSystemMetrics,SM_IMMENABLED
  pop ecx
  
  .if ecx==0
    mov ecx,offset _minus
  .else
    mov ecx,offset _plus
  .endif
  
  .if eax==0
    mov eax,offset _minus
  .else
    mov eax,offset _plus
  .endif
  
  mov edx,var
  .if edx==1 || edx==0
    mov edx,offset _e
  .elseif edx==2
    mov edx,offset _el
  .elseif edx==3
    mov edx,offset _g
  .elseif edx==4
    mov edx,offset _gl
  .elseif edx==5
    mov edx,offset _f
  .elseif edx==6
    mov edx,offset _fl
  .elseif edx==7
    mov edx,offset _gm
  .elseif edx==8
    mov edx,offset _gml
  .elseif edx==9
    mov edx,offset _zd
  .elseif edx==10
    mov edx,offset _zdl
  .elseif edx==11
    mov edx,offset _zu
  .else ; if edx==12
    mov edx,offset _zul
  .endif
  push edx

  invoke wsprintf,offset buffer,offset _format4,offset wintext1,ecx,eax,hwfr,hwfc,pt.x,pt.y,edx
  invoke lstrcat,lp_bigbuf,offset buffer
  invoke lstrcat,lp_bigbuf,offset _cmndlnprm
  invoke lstrlen,eax
  mov edx,count   ; -
  mov count0,edx  ; -
  mov	count,eax

  invoke GetTickCount
  pop edx
  invoke wsprintf,offset shiftbuf,offset _format5,count0o,count0,eax,edx

  invoke CreateFile,offset shiftbuf,GENERIC_READ or GENERIC_WRITE,FILE_SHARE_READ,0,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,0
  cmp	eax,INVALID_HANDLE_VALUE
  jz @f
  push eax
  invoke WriteFile,eax,lp_bigbuf,count,addr count,0
  call CloseHandle
@@:
  invoke DeleteObject,hrgn
  invoke VirtualFree,lp_wtbuf,0,MEM_RELEASE
  mov edx,var
  .if edx==2 || edx==4 || edx==6 || edx==8 || edx==10 || edx==12    ; (WTS-In-Loop)
    jmp @start
@exit:
    invoke MessageBeep,MB_ICONHAND
  .endif
  invoke ExitProcess,0
  invoke InitCommonControls
end start

;###########################################################################################
